import type { ACK } from '../dto/ACK';
import type { NACK, NACK_ERROR_WARNING } from '../dto/NACK';
import type { Ack } from '../entity/ack';
import type { Nack, NackErrorWarning } from '../entity/nack';
/**
 * @public
 */
export declare const fromDTOStringArray: (arr: string[]) => string[];
/**
 * @public
 */
export declare const fromDTONackErrorWarningArray: (arr: NACK_ERROR_WARNING[]) => NackErrorWarning[];
/**
 * includesErrorWarningCode
 * @public
 */
export declare const includesErrorWarningCode: (arr: NACK_ERROR_WARNING[], code: string) => boolean;
/**
 * hasDTOErrorWarningCode
 * @remarks
 * Checks both the `CODE` and `STATUS_CODE` values for a match.
 * @param dto - NACK.
 * @param code - The error or warning code.
 * @public
 */
export declare const hasDTOErrorWarningCode: (dto: NACK, code: string) => boolean;
/**
 * fromDTOAck
 * @param dto - ACK.
 * @public
 */
export declare const fromDTOAck: (dto: ACK) => Ack;
/**
 * fromDTONack
 * @param dto - NACK.
 * @public
 */
export declare const fromDTONack: (dto: NACK) => Nack;
//# sourceMappingURL=utils.d.ts.map