import { FoundationAnalytics } from '@genesislcap/foundation-comms';
import { Constructable } from '@microsoft/fast-element';
import { Container } from '@microsoft/fast-foundation';
import { RouterConfiguration } from '@microsoft/fast-router';
import { User } from '../entity';
import { AuthConfig } from '../main/config';
import type { Settings } from './types';
/**
 * Base implementation of a routing used with the Auth class
 *
 * @internal
 */
export declare class MainRouterConfig extends RouterConfiguration<Settings> {
    private user;
    private container;
    private analytics;
    private authConfig;
    constructor(user: User, container: Container, analytics: FoundationAnalytics, authConfig: AuthConfig);
    configure(): void;
    construct<T>(Type: Constructable<T>): T;
}
//# sourceMappingURL=config.d.ts.map