import { GenesisServerError } from '@genesislcap/foundation-state-machine';
/**
 * AuthError.
 * @public
 */
export class AuthError extends GenesisServerError {
    constructor(sent, received, message = 'Auth Error Occurred') {
        super(sent, received, message);
        this.sent = sent;
        this.received = received;
        this.name = 'AuthError';
        Object.setPrototypeOf(this, AuthError.prototype);
    }
    hasPasswordExpiredError() {
        return this.hasErrorCode('PASSWORD_EXPIRED');
    }
}
/**
 * @public
 */
export const isAuthError = (error) => error instanceof isAuthError;
