## API Report File for "@genesislcap/foundation-auth"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { AbstractMachine } from '@genesislcap/foundation-state-machine';
import { AbstractStore } from '@genesislcap/foundation-store';
import { AbstractStoreRoot } from '@genesislcap/foundation-store';
import { Auth as Auth_2 } from '@genesislcap/foundation-comms';
import { AuthInfo } from '@genesislcap/foundation-comms';
import { Binding } from '@microsoft/fast-element';
import { Connect } from '@genesislcap/foundation-comms';
import { Constructable } from '@microsoft/fast-element';
import { Container } from '@microsoft/fast-foundation';
import { Controller } from '@microsoft/fast-element';
import { CredentialManager } from '@genesislcap/foundation-comms';
import { DefineFunction } from '@genesislcap/foundation-ui';
import type { DoneInvokeEvent } from 'xstate';
import { ElementStyles } from '@microsoft/fast-element';
import { EmitOptions } from '@genesislcap/foundation-events';
import { EmitReturn } from '@genesislcap/foundation-events';
import type { ErrorEvent as ErrorEvent_2 } from 'xstate';
import { FASTElement } from '@microsoft/fast-element';
import { FetchMachine } from '@genesislcap/foundation-state-machine';
import { FetchMachineEvent } from '@genesislcap/foundation-state-machine';
import { FoundationAnalytics } from '@genesislcap/foundation-comms';
import { GenesisServerError } from '@genesislcap/foundation-state-machine';
import { InterfaceSymbol } from '@microsoft/fast-foundation';
import type { InterpreterOptions } from 'xstate';
import { Key } from '@microsoft/fast-foundation';
import { KeysMatching } from '@genesislcap/foundation-events';
import { Logger } from '@genesislcap/foundation-utils';
import { Machine } from '@genesislcap/foundation-state-machine';
import type { MachineContext } from '@genesislcap/foundation-state-machine';
import { Message as Message_2 } from '@genesislcap/foundation-comms';
import { MessageBuilder } from '@genesislcap/foundation-comms';
import { NavigationPhase } from '@microsoft/fast-router';
import { PartialFASTElementDefinition } from '@microsoft/fast-element';
import { RouterConfiguration } from '@microsoft/fast-router';
import { Session } from '@genesislcap/foundation-comms';
import { Store } from '@genesislcap/foundation-store';
import { StoreRoot } from '@genesislcap/foundation-store';
import { StoreRootEventDetailMap } from '@genesislcap/foundation-store';
import { SyntheticViewTemplate } from '@microsoft/fast-element';
import { TemplateElementDependency } from '@genesislcap/foundation-ui';
import { UUID } from '@genesislcap/foundation-utils';
import { ViewTemplate } from '@microsoft/fast-element';

// Warning: (ae-forgotten-export) The symbol "Auth_base" needs to be exported by the entry point index.d.ts
//
// @public (undocumented)
export class Auth extends Auth_base {
    // @internal
    actionQueryParams(): void;
    // @internal (undocumented)
    protected addEventListeners(): void;
    // @internal (undocumented)
    cm: CredentialManager;
    // @internal
    config: MainRouterConfig;
    // @internal (undocumented)
    connectedCallback(): Promise<void>;
    // @internal
    container: Container;
    // @internal (undocumented)
    disconnectedCallback(): void;
    // (undocumented)
    loginWithCookies(): void;
    // (undocumented)
    loginWithCredentials(credentials: AuthInfo): void;
    // (undocumented)
    logout(): void;
    // @internal
    provider: HTMLElement;
    // @internal
    ready: boolean;
    // @internal (undocumented)
    protected readyStore(): void;
    // @internal
    registerCommonComponents(): Promise<void>;
    // @internal (undocumented)
    protected registerDIDependencies(): void;
    // @internal (undocumented)
    protected removeEventListeners(): void;
    // @internal
    session: Session;
    // @internal (undocumented)
    store: AuthStore;
}

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "AuthConfig" because one of its declarations is marked as @internal
//
// @public
export interface AuthConfig {
    autoAuth: boolean;
    autoConnect: boolean;
    background: ElementStyles;
    defaultRedirectUrl: string;
    fields: FieldConfigMap;
    hostPath: string;
    logo: ElementStyles | null;
    omitRedirectUrls: string[];
    omitRoutes: Exclude<Routes, 'login' | 'not-found'>[];
    routeToUrl: (url: string | undefined) => void;
    showConnectionIndicator: boolean;
    sso: SSOConfig | null;
    versionInformation?: string;
}

// @internal
export const AuthConfig: InterfaceSymbol<AuthConfig>;

// @public (undocumented)
export type AuthDTO = LoginDTO | LogoutDTO;

// @public (undocumented)
export type AuthEntity = LoginEntity | LogoutEntity;

// @public
export class AuthError extends GenesisServerError {
    constructor(sent?: Message_2, received?: Message_2, message?: string);
    // (undocumented)
    hasPasswordExpiredError(): boolean;
    // (undocumented)
    received?: Message_2;
    // (undocumented)
    sent?: Message_2;
}

// @public (undocumented)
export type AuthEventMap = StoreRootEventDetailMap & AuthMachineEventMap & {
    'auth-login': AuthInfo;
    'auth-login-details': void;
    'auth-logout': void;
};

// @public (undocumented)
export type AuthFormEntryEventMap = {
    'auth-autofill-form': void;
    'auth-organisation-changed': string;
    'auth-username-changed': string;
    'auth-email-changed': string;
    'auth-password-changed': string;
    'auth-password2-changed': string;
    'auth-showPasswords-changed': boolean;
};

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "AuthFormEntryStore" because one of its declarations is marked as @internal
//
// @public
export interface AuthFormEntryStore extends Store {
    // (undocumented)
    readonly email: string;
    // (undocumented)
    readonly hasErrors: boolean;
    // (undocumented)
    readonly hasPasswordExpired: boolean;
    // (undocumented)
    readonly host: string;
    // (undocumented)
    readonly idps: IDP[];
    // (undocumented)
    readonly message: string;
    // (undocumented)
    readonly mfaCode: string;
    // (undocumented)
    onAutofillForm(event: CustomEvent<void>): void;
    // (undocumented)
    onEmailChanged(event: CustomEvent<string>): void;
    // (undocumented)
    onOrganisationChanged(event: CustomEvent<string>): void;
    // (undocumented)
    onPassword2Changed(event: CustomEvent<string>): void;
    // (undocumented)
    onPasswordChanged(event: CustomEvent<string>): void;
    // (undocumented)
    onShowPasswordsChanged(event: CustomEvent<boolean>): void;
    // (undocumented)
    onUsernameChanged(event: CustomEvent<string>): void;
    // (undocumented)
    readonly organisation: string;
    // (undocumented)
    readonly orgUsername: string;
    // (undocumented)
    readonly password: string;
    // (undocumented)
    readonly password2: string;
    // (undocumented)
    readonly passwordResetToken: string;
    // (undocumented)
    readonly selectedIDP: string;
    // (undocumented)
    readonly showPasswords: boolean;
    // (undocumented)
    readonly ssoToggled: boolean;
    // (undocumented)
    readonly termsAgreed: boolean;
    // (undocumented)
    readonly username: string;
}

// @internal
export const AuthFormEntryStore: InterfaceSymbol<Key>;

// @beta (undocumented)
export class AuthHosted extends Auth {
    // (undocumented)
    registerCommonComponents(): Promise<void>;
}

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "AuthMachine" because one of its declarations is marked as @internal
//
// @public
export interface AuthMachine extends Machine<AuthMachineContext, AuthMachineEvent> {
}

// @internal
export const AuthMachine: InterfaceSymbol<AuthMachine>;

// @public
export interface AuthMachineContext extends MachineContext {
    authDTO: AuthDTO;
    authEntity: AuthEntity;
    credentials?: AuthInfo;
    mapper: Mapper<AuthDTO, AuthEntity>;
    user: User;
}

// @public
export type AuthMachineEvent = {
    type: 'login';
    params: {
        credentials?: AuthInfo;
    };
} | {
    type: 'logout';
} | {
    type: 'openSocket';
} | {
    type: 'closeSocket';
} | {
    type: 'login-details';
} | DoneInvokeEvent<unknown> | ErrorEvent_2<unknown>;

// @public
export type AuthMachineEventMap = {
    'auth-machine-event': AuthMachineEvent;
};

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "AuthStore" because one of its declarations is marked as @internal
//
// @public
export interface AuthStore extends StoreRoot {
    readonly authMachine: AuthMachine;
    // (undocumented)
    readonly formEntry: AuthFormEntryStore;
    // (undocumented)
    readonly isPending: boolean;
    // (undocumented)
    onLogin(event: CustomEvent<AuthInfo>): void;
    // (undocumented)
    onLoginDetails(event: CustomEvent<void>): void;
    // (undocumented)
    onLogout(event: CustomEvent<void>): void;
    // (undocumented)
    onMachineEvent(event: CustomEvent<AuthEventMap['auth-machine-event']>): void;
}

// @internal
export const AuthStore: InterfaceSymbol<Key>;

// Warning: (ae-internal-missing-underscore) The name "backButton" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const backButton: <T extends ConfigHost>(binding: Binding) => ViewTemplate<T, any>;

// Warning: (ae-internal-missing-underscore) The name "BackgroundElement" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export class BackgroundElement extends ConfigHostElement {
    // (undocumented)
    connectedCallback(): void;
}

// Warning: (ae-internal-missing-underscore) The name "BaseRoute" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export class BaseRoute extends ConfigHostElement {
    // (undocumented)
    auth: Auth_2;
    // (undocumented)
    clearError(): void;
    // (undocumented)
    connect: Connect;
    // (undocumented)
    connectedCallback(): void;
    // (undocumented)
    credentialManager: CredentialManager;
    // (undocumented)
    email: string;
    // (undocumented)
    ensureConnection(): Promise<boolean>;
    // (undocumented)
    enter(phase: NavigationPhase<Settings>): void;
    // (undocumented)
    getSubRoutePath(routeName: Routes | string): string;
    // (undocumented)
    hasErrors: boolean;
    // (undocumented)
    host: string;
    // (undocumented)
    isSubmitting: boolean;
    // (undocumented)
    message: string;
    // (undocumented)
    messageBuilder: MessageBuilder;
    // (undocumented)
    protected navigationPhase: NavigationPhase<Settings>;
    // (undocumented)
    onBack: () => void;
    // (undocumented)
    onNavigate: (path: string) => void;
    // (undocumented)
    onSubmit(): Promise<void>;
    // (undocumented)
    organisation: string;
    // (undocumented)
    get orgUsername(): string;
    // (undocumented)
    password: string;
    // (undocumented)
    password2: string;
    // (undocumented)
    queueOnBack(delay?: number): void;
    // (undocumented)
    sendMessage<T = any>(message: Message_2<T>, successFeedback?: string, successCallback?: (result: any) => void): Promise<void>;
    // (undocumented)
    session: Session;
    // (undocumented)
    setError(message: string): void;
    // (undocumented)
    showPasswords: boolean;
    // (undocumented)
    store: AuthStore;
    // (undocumented)
    storeCredentials(password?: string): void;
    // (undocumented)
    user: User;
    // (undocumented)
    username: string;
}

// Warning: (ae-internal-missing-underscore) The name "ConfigHost" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export type ConfigHost = {
    config: AuthConfig;
};

// Warning: (ae-forgotten-export) The symbol "ConfigHostElement_base" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-missing-underscore) The name "ConfigHostElement" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export class ConfigHostElement extends ConfigHostElement_base implements ConfigHost {
    // (undocumented)
    config: AuthConfig;
    // (undocumented)
    connectedCallback(): void;
    // (undocumented)
    container: Container;
}

// @public
export function configure(container: Container, config: Partial<AuthConfig>): void;

// @public (undocumented)
export const defaultApiHost: string;

// @public
export const defaultAuthConfig: AuthConfig;

// Warning: (ae-forgotten-export) The symbol "InternalEventMap" needs to be exported by the entry point index.d.ts
//
// @public
export class DefaultAuthFormEntryStore extends AbstractStore<AuthFormEntryStore, AuthFormEntryEventMap, InternalEventMap> implements AuthFormEntryStore {
    constructor();
    // (undocumented)
    protected config: AuthConfig;
    // (undocumented)
    protected credentialManager: CredentialManager;
    // (undocumented)
    email: string;
    // (undocumented)
    hasErrors: boolean;
    // (undocumented)
    hasPasswordExpired: boolean;
    // (undocumented)
    host: string;
    // (undocumented)
    idps: IDP[];
    // (undocumented)
    message: string;
    // (undocumented)
    mfaCode: string;
    // (undocumented)
    onAutofillForm: EventListener;
    // (undocumented)
    onEmailChanged: EventListener;
    // (undocumented)
    onOrganisationChanged: EventListener;
    // (undocumented)
    onPassword2Changed: EventListener;
    // (undocumented)
    onPasswordChanged: EventListener;
    // (undocumented)
    onShowPasswordsChanged: EventListener;
    // (undocumented)
    onUsernameChanged: EventListener;
    // (undocumented)
    organisation: string;
    // (undocumented)
    get orgUsername(): string;
    // (undocumented)
    password: string;
    // (undocumented)
    password2: string;
    // (undocumented)
    passwordResetToken: string;
    // (undocumented)
    selectedIDP: string;
    // (undocumented)
    showPasswords: boolean;
    // (undocumented)
    ssoToggled: boolean;
    // (undocumented)
    termsAgreed: boolean;
    // (undocumented)
    username: string;
}

// @public
export class DefaultAuthMachine extends AbstractMachine<AuthMachineContext, AuthMachineEvent> implements AuthMachine {
    constructor(user: User, connect: Connect, fetchMachine: FetchMachine, messageBuilder: MessageBuilder, credentialManager: CredentialManager, uuid: UUID, loginMapper: LoginMapper, logoutMapper: LogoutMapper, config: AuthConfig);
    // (undocumented)
    addLoginEvents(): {
        login: {
            actions: string[];
            target: string;
        };
        "login-details": {
            target: string;
        };
    };
    // (undocumented)
    createFetchMachineEvent(url: string, msg?: Message_2): FetchMachineEvent;
    getFromContainer(): this;
    // (undocumented)
    start(options?: InterpreterOptions<typeof DefaultAuthMachine.machine>): void;
}

// @public
export const defaultAuthMachineContext: Partial<AuthMachineContext>;

// Warning: (ae-forgotten-export) The symbol "InternalAuthEventMap" needs to be exported by the entry point index.d.ts
//
// @public
export class DefaultAuthStore extends AbstractStoreRoot<AuthStore, AuthEventMap, InternalAuthEventMap> implements AuthStore {
    constructor(config: AuthConfig, authMachine: AuthMachine, formEntry: AuthFormEntryStore);
    // (undocumented)
    readonly authMachine: AuthMachine;
    // (undocumented)
    readonly config: AuthConfig;
    // (undocumented)
    readonly formEntry: AuthFormEntryStore;
    // (undocumented)
    get isPending(): boolean;
    // (undocumented)
    onLogin: EventListener;
    // (undocumented)
    onLoginDetails: EventListener;
    // (undocumented)
    onLogout: EventListener;
    // (undocumented)
    onMachineEvent: EventListener;
}

// @public
export class DefaultLoginMapper implements LoginMapper {
    // Warning: (ae-forgotten-export) The symbol "Product_2" needs to be exported by the entry point index.d.ts
    //
    // (undocumented)
    protected fromProductDTO: (products: Product_2[]) => Product[];
    // Warning: (ae-forgotten-export) The symbol "System_2" needs to be exported by the entry point index.d.ts
    //
    // (undocumented)
    protected fromSystemDTO: (system: System_2) => System;
    toEntity: (dto: LoginDTO) => Promise<LoginEntity>;
}

// @public
export class DefaultLogoutMapper implements LogoutMapper {
    toEntity: (dto: LogoutDTO) => Promise<LogoutEntity>;
}

// Warning: (ae-internal-missing-underscore) The name "defaultOnBackMS" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const defaultOnBackMS = 3000;

// @public (undocumented)
export const defaultOrganisation: string;

// @public (undocumented)
export const defaultPassword: string;

// @public (undocumented)
export const defaultSocketExt: string;

// @beta
export const defaultTemplateOptions: TemplateOptions;

// @public
export class DefaultUser implements User {
    // (undocumented)
    actionHistory: unknown[];
    // (undocumented)
    clearActions(): void;
    // (undocumented)
    clearPaths(): void;
    // (undocumented)
    details: Details;
    // (undocumented)
    protected hasKey(keys: string[], key: string | string[]): boolean;
    // (undocumented)
    hasPermission(permission: string | string[]): boolean;
    // (undocumented)
    hasProfile(profile: string | string[]): boolean;
    // (undocumented)
    isAdmin(): boolean;
    // (undocumented)
    isAnonymous(): boolean;
    // (undocumented)
    isAuthenticated(): boolean;
    // (undocumented)
    isBanned(): boolean;
    // (undocumented)
    lastAction(): unknown;
    // (undocumented)
    lastPath(): string;
    // (undocumented)
    pathHistory: string[];
    // (undocumented)
    permission: string[];
    // (undocumented)
    profile: string[];
    // (undocumented)
    refreshAuthToken: string;
    // (undocumented)
    sessionAuthToken: string;
    // (undocumented)
    sessionId: string;
    // (undocumented)
    set(entity: Partial<LoginAck>): this;
    // (undocumented)
    sourceRef: string;
    // (undocumented)
    trackAction<TDetails = unknown>(details: TDetails): void;
    // (undocumented)
    trackPath(ignoreEmpty?: boolean): string;
    // (undocumented)
    unset(): this;
    // (undocumented)
    userKVs: {
        [key: string]: any;
    };
    // (undocumented)
    userName: string;
    // (undocumented)
    get username(): string;
    // (undocumented)
    protected userNameChanged(): void;
}

// @public (undocumented)
export const defaultUser: string;

// @beta
export const define: DefineFunction<typeof Auth>;

// @beta (undocumented)
export const definition: PartialFASTElementDefinition;

// @public (undocumented)
export interface Details {
    // (undocumented)
    readonly daysToPasswordExpiry: number;
    // (undocumented)
    readonly failedLoginAttempts: number;
    // (undocumented)
    readonly heartbeatIntervalSecs: number;
    // (undocumented)
    readonly lastLoginDatetime: number;
    // (undocumented)
    readonly product: Product[];
    // (undocumented)
    readonly rejectedLoginAttempts: number;
    // (undocumented)
    readonly system: System | null;
}

// Warning: (ae-internal-missing-underscore) The name "emailField" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const emailField: <T extends BaseRoute>() => ViewTemplate<T, any>;

// Warning: (ae-forgotten-export) The symbol "ACK" needs to be exported by the entry point index.d.ts
//
// @public (undocumented)
export interface EVENT_LOGIN_AUTH_ACK extends ACK {
    // Warning: (ae-forgotten-export) The symbol "Details_2" needs to be exported by the entry point index.d.ts
    //
    // (undocumented)
    readonly DETAILS: Details_2;
    // (undocumented)
    readonly PERMISSION: string[];
    // (undocumented)
    readonly PROFILE: string[];
    // (undocumented)
    readonly REFRESH_AUTH_TOKEN: string;
    // (undocumented)
    readonly SESSION_AUTH_TOKEN: string;
    // (undocumented)
    readonly SESSION_ID: string;
    // (undocumented)
    readonly UPDATE_QUEUE: string;
    // (undocumented)
    readonly USER: {
        [key: string]: any;
    };
    // (undocumented)
    readonly USER_NAME: string;
    // (undocumented)
    readonly ZERO_MQ_PROXY_INBOUND_PORT: number;
    // (undocumented)
    readonly ZERO_MQ_PROXY_MODE_ENABLED: boolean;
    // (undocumented)
    readonly ZERO_MQ_PROXY_OUTBOUND_PORT: number;
}

// Warning: (ae-forgotten-export) The symbol "NACK" needs to be exported by the entry point index.d.ts
//
// @public (undocumented)
export interface EVENT_LOGIN_AUTH_NACK extends NACK {
}

// @public (undocumented)
export interface EVENT_LOGIN_DETAILS_ACK extends EVENT_LOGIN_AUTH_ACK {
}

// @public (undocumented)
export interface EVENT_LOGOUT_NACK extends NACK {
}

// @public
export const fetchIDPs: (path?: string, host?: string) => Promise<IDP[]>;

// @public
export type FieldConfig = {
    label: string;
    value?: any;
    required?: boolean;
    pattern?: string;
    title?: string;
};

// @public (undocumented)
export type FieldConfigMap = {
    organisation: FieldConfig | null;
    username: FieldConfig;
    email: FieldConfig;
    password: FieldConfig;
};

// Warning: (ae-forgotten-export) The symbol "Ack" needs to be exported by the entry point index.d.ts
//
// @public
export const fromDTOAck: (dto: ACK) => Ack;

// Warning: (ae-forgotten-export) The symbol "Nack" needs to be exported by the entry point index.d.ts
//
// @public
export const fromDTONack: (dto: NACK) => Nack;

// Warning: (ae-forgotten-export) The symbol "NACK_ERROR_WARNING" needs to be exported by the entry point index.d.ts
// Warning: (ae-forgotten-export) The symbol "NackErrorWarning" needs to be exported by the entry point index.d.ts
//
// @public (undocumented)
export const fromDTONackErrorWarningArray: (arr: NACK_ERROR_WARNING[]) => NackErrorWarning[];

// @public (undocumented)
export const fromDTOStringArray: (arr: string[]) => string[];

// @public
export const getSSOLoginURL: (idp: any, path?: string, host?: string) => string;

// @public
export const hasDTOErrorWarningCode: (dto: NACK, code: string) => boolean;

// @public (undocumented)
export const hostEnv: string;

// @public (undocumented)
export const hostUrl: string;

// @public (undocumented)
export interface IDP {
    // (undocumented)
    id: string;
    // (undocumented)
    type: string;
}

// @public (undocumented)
export interface IDPResponse {
    // (undocumented)
    ID: string;
    // (undocumented)
    TYPE: string;
}

// @public
export const includesErrorWarningCode: (arr: NACK_ERROR_WARNING[], code: string) => boolean;

// Warning: (ae-forgotten-export) The symbol "EventMap" needs to be exported by the entry point index.d.ts
// Warning: (ae-internal-missing-underscore) The name "inputEmit" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const inputEmit: <K extends KeysMatching<EventMap, string>>(type: K, options?: EmitOptions) => Binding<any, any, any>;

// @public (undocumented)
export const isAuthError: (error: unknown) => boolean;

// @public
export function isLoginAckDTO(dto: LoginDTO): dto is EVENT_LOGIN_AUTH_ACK;

// @public
export function isLoginAckEntity(entity: LoginEntity): entity is LoginAck;

// @public
export function isLoginDetailsAckDTO(dto: LoginDTO): dto is EVENT_LOGIN_DETAILS_ACK;

// @public
export function isLoginDetailsAckEntity(entity: LoginEntity): entity is LoginDetailsAck;

// @public
export function isLoginNackDTO(dto: LoginDTO): dto is EVENT_LOGIN_AUTH_NACK;

// @public
export function isLoginNackEntity(entity: LoginEntity): entity is LoginNack;

// @public
export function isLogoutAckDTO(dto: LogoutDTO): dto is LOGOUT_ACK;

// @public
export function isLogoutAckEntity(entity: LogoutEntity): entity is LogoutAck;

// @public
export function isLogoutNackDTO(dto: LogoutDTO): dto is EVENT_LOGOUT_NACK;

// @public
export function isLogoutNackEntity(entity: LogoutEntity): entity is LogoutNack;

// @public
export function isMFRoute(pathname?: string): boolean;

// @public (undocumented)
export const logger: Logger;

// @public (undocumented)
export let LOGIN_DETAILS_URL: string;

// @public (undocumented)
export let LOGIN_REFRESH_URL: string;

// @public (undocumented)
export let LOGIN_URL: string;

// @public (undocumented)
export interface LoginAck extends Ack {
    // (undocumented)
    readonly details: Details;
    // (undocumented)
    readonly permission: string[];
    // (undocumented)
    readonly profile: string[];
    // (undocumented)
    readonly refreshAuthToken: string;
    // (undocumented)
    readonly sessionAuthToken: string;
    // (undocumented)
    readonly sessionId: string;
    // (undocumented)
    readonly updateQueue: string;
    // (undocumented)
    readonly userKVs: {
        [key: string]: any;
    };
    // (undocumented)
    readonly userName: string;
    // (undocumented)
    readonly zeroMqProxyInboundPort: number;
    // (undocumented)
    readonly zeroMqProxyModeEnabled: boolean;
    // (undocumented)
    readonly zeroMqProxyOutboundPort: number;
}

// @public (undocumented)
export interface LoginDetailsAck extends LoginAck {
}

// @public
export type LoginDTO = EVENT_LOGIN_AUTH_ACK | EVENT_LOGIN_DETAILS_ACK | EVENT_LOGIN_AUTH_NACK;

// @public
export type LoginEntity = LoginAck | LoginDetailsAck | LoginNack;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "LoginMapper" because one of its declarations is marked as @internal
//
// @public
export interface LoginMapper extends Mapper<LoginDTO, LoginEntity> {
}

// @internal
export const LoginMapper: InterfaceSymbol<LoginMapper>;

// @public (undocumented)
export interface LoginNack extends Nack {
    // (undocumented)
    readonly hasPasswordExpired: boolean;
    // (undocumented)
    readonly isMFARequired: boolean;
}

// Warning: (ae-internal-missing-underscore) The name "LogoElement" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export class LogoElement extends ConfigHostElement {
}

// @public (undocumented)
export interface LOGOUT_ACK extends ACK {
    // (undocumented)
    readonly OIDC_LOGOUT_URL: string;
}

// @public (undocumented)
export let LOGOUT_URL: string;

// @public (undocumented)
export interface LogoutAck extends Ack {
    // (undocumented)
    readonly oidcLogoutUrl: string;
}

// @public
export type LogoutDTO = LOGOUT_ACK | EVENT_LOGOUT_NACK;

// @public
export type LogoutEntity = LogoutAck | LogoutNack;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "LogoutMapper" because one of its declarations is marked as @internal
//
// @public
export interface LogoutMapper extends Mapper<LogoutDTO, LogoutEntity> {
}

// @internal
export const LogoutMapper: InterfaceSymbol<LogoutMapper>;

// @public (undocumented)
export interface LogoutNack extends Nack {
}

// Warning: (ae-internal-missing-underscore) The name "MainRouterConfig" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal
export class MainRouterConfig extends RouterConfiguration<Settings> {
    constructor(user: User, container: Container, analytics: FoundationAnalytics, authConfig: AuthConfig);
    // (undocumented)
    configure(): void;
    // (undocumented)
    construct<T>(Type: Constructable<T>): T;
}

// @public
export interface Mapper<TDTO, TEntity> {
    toDTO?: (entity: Partial<TEntity>) => Promise<TDTO>;
    toEntity: (dto: TDTO) => Promise<TEntity>;
}

// Warning: (ae-internal-missing-underscore) The name "MessageElement" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export class MessageElement extends FASTElement {
    // (undocumented)
    classNames: string;
    // (undocumented)
    message: string;
    // (undocumented)
    nonError: boolean;
    // (undocumented)
    nonErrorChanged(): void;
}

// Warning: (ae-internal-missing-underscore) The name "organisationField" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const organisationField: <T extends BaseRoute>() => ViewTemplate<T, any>;

// Warning: (ae-internal-missing-underscore) The name "password2Field" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const password2Field: <T extends BaseRoute>(type: 'new' | 'confirmation') => ViewTemplate<T, any>;

// Warning: (ae-internal-missing-underscore) The name "passwordField" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const passwordField: <T extends BaseRoute>(label?: string) => ViewTemplate<T, any>;

// @public (undocumented)
export interface Product {
    // (undocumented)
    readonly name: string;
    // (undocumented)
    readonly version: string;
}

// @public (undocumented)
export const Routes: {
    readonly login: "login";
    readonly 'request-account': "request-account";
    readonly 'reset-password': "reset-password";
    readonly 'forgot-password': "forgot-password";
    readonly verify: "verify";
    readonly protected: "protected";
    readonly 'not-found': "not-found";
};

// @public (undocumented)
export type Routes = (typeof Routes)[keyof typeof Routes];

// Warning: (ae-internal-missing-underscore) The name "selectEmit" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const selectEmit: <K extends KeysMatching<EventMap, string>>(type: K, options?: EmitOptions) => Binding<any, any, any>;

// @public
export type Settings = {
    public?: boolean;
};

// Warning: (ae-internal-missing-underscore) The name "showPasswordsCheckbox" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const showPasswordsCheckbox: <T extends BaseRoute>() => ViewTemplate<T, any>;

// @public (undocumented)
export let SOCKET_URL: string;

// @public (undocumented)
export type SSOConfig = {
    toggled?: boolean;
    identityProvidersPath: string;
};

// Warning: (ae-internal-missing-underscore) The name "standaloneDefinition" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const standaloneDefinition: PartialFASTElementDefinition;

// Warning: (ae-incompatible-release-tags) The symbol "styles" is marked as @public, but its signature references "TemplateOptions" which is marked as @beta
//
// @public (undocumented)
export const styles: (options: TemplateOptions) => ElementStyles;

// Warning: (ae-internal-missing-underscore) The name "submitButton" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const submitButton: <T extends ConfigHost>(label: string, dataTestId?: string, disabled?: boolean) => ViewTemplate<T, any>;

// Warning: (ae-internal-missing-underscore) The name "SubmittingIndicator" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export class SubmittingIndicator extends FASTElement {
    // (undocumented)
    isSubmitting: boolean;
}

// @public (undocumented)
export interface System {
    // (undocumented)
    readonly date: string;
}

// Warning: (ae-incompatible-release-tags) The symbol "template" is marked as @public, but its signature references "TemplateOptions" which is marked as @beta
//
// @public (undocumented)
export const template: (options: TemplateOptions) => ViewTemplate<Auth, any>;

// @beta (undocumented)
export type TemplateComponents = {
    anchor: TemplateElementDependency;
    button: TemplateElementDependency;
    card: TemplateElementDependency;
    checkbox: TemplateElementDependency;
    listboxOption: TemplateElementDependency;
    provider: TemplateElementDependency;
    router: TemplateElementDependency;
    select: TemplateElementDependency;
    textField: TemplateElementDependency;
};

// @beta (undocumented)
export type TemplateOptions = TemplateComponents & {
    somePartial?: string | SyntheticViewTemplate;
};

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "User" because one of its declarations is marked as @internal
//
// @public
export interface User extends UserPathHistory, UserActionHistory {
    // (undocumented)
    readonly details: Details;
    // (undocumented)
    hasPermission(permission: string | string[]): boolean;
    // (undocumented)
    hasProfile(profile: string | string[]): boolean;
    // (undocumented)
    isAdmin(): boolean;
    // (undocumented)
    isAnonymous(): boolean;
    // (undocumented)
    isAuthenticated(): boolean;
    // (undocumented)
    isBanned(): boolean;
    // (undocumented)
    readonly profile: string[];
    // (undocumented)
    readonly refreshAuthToken: string;
    // (undocumented)
    readonly sessionAuthToken: string;
    // (undocumented)
    readonly sessionId: string;
    // (undocumented)
    set(entity: Partial<LoginAck>): this;
    // (undocumented)
    readonly sourceRef: string;
    // (undocumented)
    unset(): this;
    // (undocumented)
    readonly userKVs: {
        [key: string]: any;
    };
    // (undocumented)
    readonly userName: string;
    // (undocumented)
    readonly username: string;
}

// @internal
export const User: InterfaceSymbol<User>;

// @public
export interface UserActionHistory {
    readonly actionHistory: unknown[];
    clearActions(): void;
    // (undocumented)
    lastAction(): unknown;
    trackAction<TDetails = unknown>(details: TDetails): void;
}

// Warning: (ae-internal-missing-underscore) The name "usernameField" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const usernameField: <T extends BaseRoute>() => ViewTemplate<T, any>;

// @public
export interface UserPathHistory {
    clearPaths(): void;
    lastPath(): string | undefined;
    readonly pathHistory: string[];
    trackPath(ignoreEmpty?: boolean): string;
}

// (No @packageDocumentation comment for this package)

```
