<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-auth](./foundation-auth.md)

## foundation-auth package

## Classes

|  Class | Description |
|  --- | --- |
|  [Auth](./foundation-auth.auth.md) |  |
|  [AuthError](./foundation-auth.autherror.md) | AuthError. |
|  [AuthHosted](./foundation-auth.authhosted.md) | **_(BETA)_** |
|  [DefaultAuthFormEntryStore](./foundation-auth.defaultauthformentrystore.md) | Default implementation of the store. |
|  [DefaultAuthMachine](./foundation-auth.defaultauthmachine.md) | Default AuthMachine. |
|  [DefaultAuthStore](./foundation-auth.defaultauthstore.md) | Default implementation of the store. |
|  [DefaultLoginMapper](./foundation-auth.defaultloginmapper.md) | Default LoginMapper. |
|  [DefaultLogoutMapper](./foundation-auth.defaultlogoutmapper.md) | Default LogoutMapper. |
|  [DefaultUser](./foundation-auth.defaultuser.md) | Default User implementation. |

## Functions

|  Function | Description |
|  --- | --- |
|  [configure(container, config)](./foundation-auth.configure.md) | Configure the auth micro frontend settings. |
|  [isLoginAckDTO(dto)](./foundation-auth.isloginackdto.md) | isLoginAckDTO. |
|  [isLoginAckEntity(entity)](./foundation-auth.isloginackentity.md) | isLoginAckEntity. |
|  [isLoginDetailsAckDTO(dto)](./foundation-auth.islogindetailsackdto.md) | isLoginDetailsAckDTO. |
|  [isLoginDetailsAckEntity(entity)](./foundation-auth.islogindetailsackentity.md) | isLoginDetailsAckEntity. |
|  [isLoginNackDTO(dto)](./foundation-auth.isloginnackdto.md) | isLoginNackDTO. |
|  [isLoginNackEntity(entity)](./foundation-auth.isloginnackentity.md) | isLoginNackEntity. |
|  [isLogoutAckDTO(dto)](./foundation-auth.islogoutackdto.md) | isLogoutAckDTO. |
|  [isLogoutAckEntity(entity)](./foundation-auth.islogoutackentity.md) | isLogoutAckEntity. |
|  [isLogoutNackDTO(dto)](./foundation-auth.islogoutnackdto.md) | isLogoutNackDTO. |
|  [isLogoutNackEntity(entity)](./foundation-auth.islogoutnackentity.md) | isLogoutNackEntity. |
|  [isMFRoute(pathname)](./foundation-auth.ismfroute.md) | A utility to check if a pathname is a route of this micro frontend. |

## Interfaces

|  Interface | Description |
|  --- | --- |
|  [AuthConfig](./foundation-auth.authconfig.md) | AuthConfig DI interface. |
|  [AuthFormEntryStore](./foundation-auth.authformentrystore.md) | AuthFormEntryStore interface. |
|  [AuthMachine](./foundation-auth.authmachine.md) | AuthMachine interface. |
|  [AuthMachineContext](./foundation-auth.authmachinecontext.md) | AuthMachineContext interface. |
|  [AuthStore](./foundation-auth.authstore.md) | AuthStore interface. |
|  [Details](./foundation-auth.details.md) |  |
|  [EVENT\_LOGIN\_AUTH\_ACK](./foundation-auth.event_login_auth_ack.md) |  |
|  [EVENT\_LOGIN\_AUTH\_NACK](./foundation-auth.event_login_auth_nack.md) |  |
|  [EVENT\_LOGIN\_DETAILS\_ACK](./foundation-auth.event_login_details_ack.md) |  |
|  [EVENT\_LOGOUT\_NACK](./foundation-auth.event_logout_nack.md) |  |
|  [IDP](./foundation-auth.idp.md) |  |
|  [IDPResponse](./foundation-auth.idpresponse.md) |  |
|  [LoginAck](./foundation-auth.loginack.md) |  |
|  [LoginDetailsAck](./foundation-auth.logindetailsack.md) |  |
|  [LoginMapper](./foundation-auth.loginmapper.md) | LoginMapper interface. |
|  [LoginNack](./foundation-auth.loginnack.md) |  |
|  [LOGOUT\_ACK](./foundation-auth.logout_ack.md) |  |
|  [LogoutAck](./foundation-auth.logoutack.md) |  |
|  [LogoutMapper](./foundation-auth.logoutmapper.md) | LogoutMapper interface. |
|  [LogoutNack](./foundation-auth.logoutnack.md) |  |
|  [Mapper](./foundation-auth.mapper.md) | DTO mapper interface. |
|  [Product](./foundation-auth.product.md) |  |
|  [System](./foundation-auth.system.md) |  |
|  [User](./foundation-auth.user.md) | User interface. |
|  [UserActionHistory](./foundation-auth.useractionhistory.md) | UserActionHistory. |
|  [UserPathHistory](./foundation-auth.userpathhistory.md) | UserPathHistory. |

## Variables

|  Variable | Description |
|  --- | --- |
|  [defaultApiHost](./foundation-auth.defaultapihost.md) |  |
|  [defaultAuthConfig](./foundation-auth.defaultauthconfig.md) | Default AuthConfig DI implementation. |
|  [defaultAuthMachineContext](./foundation-auth.defaultauthmachinecontext.md) | Default AuthMachineContext. |
|  [defaultOrganisation](./foundation-auth.defaultorganisation.md) |  |
|  [defaultPassword](./foundation-auth.defaultpassword.md) |  |
|  [defaultSocketExt](./foundation-auth.defaultsocketext.md) |  |
|  [defaultTemplateOptions](./foundation-auth.defaulttemplateoptions.md) | **_(BETA)_** The default template options this MF has been created with. |
|  [defaultUser](./foundation-auth.defaultuser.md) |  |
|  [define](./foundation-auth.define.md) | **_(BETA)_** Re-define the auth micro frontend. |
|  [definition](./foundation-auth.definition.md) | **_(BETA)_** |
|  [fetchIDPs](./foundation-auth.fetchidps.md) | Request SSO identity provider list |
|  [fromDTOAck](./foundation-auth.fromdtoack.md) | fromDTOAck |
|  [fromDTONack](./foundation-auth.fromdtonack.md) | fromDTONack |
|  [fromDTONackErrorWarningArray](./foundation-auth.fromdtonackerrorwarningarray.md) |  |
|  [fromDTOStringArray](./foundation-auth.fromdtostringarray.md) |  |
|  [getSSOLoginURL](./foundation-auth.getssologinurl.md) | Get SSO identity provider login URL |
|  [hasDTOErrorWarningCode](./foundation-auth.hasdtoerrorwarningcode.md) | hasDTOErrorWarningCode |
|  [hostEnv](./foundation-auth.hostenv.md) |  |
|  [hostUrl](./foundation-auth.hosturl.md) |  |
|  [includesErrorWarningCode](./foundation-auth.includeserrorwarningcode.md) | includesErrorWarningCode |
|  [isAuthError](./foundation-auth.isautherror.md) |  |
|  [logger](./foundation-auth.logger.md) |  |
|  [LOGIN\_DETAILS\_URL](./foundation-auth.login_details_url.md) |  |
|  [LOGIN\_REFRESH\_URL](./foundation-auth.login_refresh_url.md) |  |
|  [LOGIN\_URL](./foundation-auth.login_url.md) |  |
|  [LOGOUT\_URL](./foundation-auth.logout_url.md) |  |
|  [Routes](./foundation-auth.routes.md) |  |
|  [SOCKET\_URL](./foundation-auth.socket_url.md) |  |
|  [styles](./foundation-auth.styles.md) |  |
|  [template](./foundation-auth.template.md) |  |

## Type Aliases

|  Type Alias | Description |
|  --- | --- |
|  [AuthDTO](./foundation-auth.authdto.md) |  |
|  [AuthEntity](./foundation-auth.authentity.md) |  |
|  [AuthEventMap](./foundation-auth.autheventmap.md) |  |
|  [AuthFormEntryEventMap](./foundation-auth.authformentryeventmap.md) |  |
|  [AuthMachineEvent](./foundation-auth.authmachineevent.md) | AuthMachineEvent type. |
|  [AuthMachineEventMap](./foundation-auth.authmachineeventmap.md) | AuthMachineEventMap type. |
|  [FieldConfig](./foundation-auth.fieldconfig.md) | Could be expanded to allow field ViewTemplates. |
|  [FieldConfigMap](./foundation-auth.fieldconfigmap.md) |  |
|  [LoginDTO](./foundation-auth.logindto.md) | LoginDTO type. |
|  [LoginEntity](./foundation-auth.loginentity.md) | LoginEntity type. |
|  [LogoutDTO](./foundation-auth.logoutdto.md) | LogoutDTO type. |
|  [LogoutEntity](./foundation-auth.logoutentity.md) | LogoutEntity type. |
|  [Routes](./foundation-auth.routes.md) |  |
|  [Settings](./foundation-auth.settings.md) | Defines the parameters you may set on the routes. |
|  [SSOConfig](./foundation-auth.ssoconfig.md) |  |
|  [TemplateComponents](./foundation-auth.templatecomponents.md) | **_(BETA)_** |
|  [TemplateOptions](./foundation-auth.templateoptions.md) | **_(BETA)_** |

